// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep

#include "Test/Operators/VariationalInstances/Viscoelasticity/ExpectedResults.hpp"


// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)
namespace MoReFEM::TestNS::ViscoelasticityNS
{


    template<>
    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP2P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::displacement>()
    {
        return expected_results_type<LinearAlgebraNS::type::matrix>{
            { 3.9662520356329244e-02,  5.7149812113971941e-03,  -1.4978254587308872e-02, -5.4669471440373677e-03,
              -1.3363226912971865e-02, -2.3004666335971546e-02, 4.1119615606557802e-02,  -1.5732120157582378e-04,
              -1.6967094866935265e-02, 1.1597766643587543e-02,  3.8764003623938973e-03,  2.3461361668215022e-02,
              1.2606233225229405e-01,  2.6492586557738371e-02,  4.3971355816817638e-02,  5.2168542219495170e-02,
              -1.5260821733050302e-02, -7.6017636030949631e-02, -1.3407605105584569e-01, 1.2311291282823747e-02,
              1.0338210240183676e-01,  1.0966524162496253e-02,  1.1183168492901638e-02,  -3.4362832704513069e-02,
              -6.5605667811587817e-02, -2.3295102040958787e-02, -2.0620836253588459e-02, -7.6428635229289166e-02,
              -7.5019560186980749e-03, 1.5136500892397375e-02 },
            { 3.0443395975800081e-02,  4.0556565448921757e-02,  -6.6182960241425596e-03, 1.0451506030203022e-02,
              -1.8360346976138746e-02, -1.5129549429780325e-02, 3.2165703063373491e-02,  3.8834929717199533e-02,
              -1.6483529173242164e-02, -3.9874338198537694e-04, 3.4972775021422389e-02,  4.8319268469489245e-03,
              -7.8269829507174413e-02, 1.8000049209513411e-01,  1.1997556484153429e-01,  4.4977048466892544e-02,
              -3.7413150015618402e-02, -7.7454588246425260e-02, -6.2104331602067686e-02, -7.1828880712707890e-02,
              3.2029707039311558e-02,  -1.5287184655194318e-02, -3.3426002792974210e-02, 1.7507707397318748e-02,
              3.2951054383160157e-02,  -7.1759594571925600e-02, -4.4519883306323900e-02, 5.0713812269924914e-03,
              -6.1576787213312938e-02, -1.4139059945199334e-02 },
            { -2.3280278318123758e-04, 1.9812174131436988e-02,  4.0150560234132646e-02,  -8.8227418276807766e-03,
              -8.0268010131158201e-04, -6.0758868417186158e-03, 1.2532283265007644e-02,  6.6014171514711759e-03,
              1.8923761308436350e-02,  -3.2099203526863407e-02, 9.1793477733107653e-03,  7.2888721266697709e-02,
              -3.3700492047735613e-02, 3.9848662643052098e-02,  2.1816681752933795e-01,  3.5948698343980186e-02,
              -7.5989468565544026e-03, -5.1518334829346840e-02, -9.7993345145768032e-02, -5.3056046271170079e-03,
              4.8262497526999092e-02,  7.6481522880203542e-03,  -2.9326332763482178e-03, -4.6298061320243673e-02,
              4.7917773863454437e-02,  -4.5336054666532406e-02, -1.5796183298288644e-01, 6.8801677570766426e-02,
              -1.3465682171407419e-02, -1.3653824189140817e-01 },
            { -8.7945945443860321e-03, 1.5788465070175276e-03,  5.9746571110988198e-03,  -1.6842390892795364e-02,
              6.4449925603636262e-03,  1.4977399191839470e-02,  -3.4882114157147696e-03, 3.0226269608887076e-04,
              9.8709754617084728e-05,  -1.5777540614381903e-02, 1.9982143817237020e-04,  6.9332550690722763e-04,
              3.1732531073041803e-02,  -6.0481612813593792e-03, -1.8908796935388751e-02, -3.4423635826886637e-02,
              4.5476580188306744e-03,  1.1718991589539620e-02,  4.8452481108547676e-02,  -6.0115903532584544e-03,
              -1.2708149693628639e-02, -3.6939998617113022e-02, -2.1511909639365381e-03, 2.6998905776378361e-02,
              6.5569079631163762e-02,  1.8666839249564344e-03,  -2.7593326469061985e-02, -2.9487719901475497e-02,
              -7.2932254687513071e-04, -1.2517158323011957e-03 },
            { -1.5477506063192162e-02, -9.6460793650425310e-03, 9.9447746668283234e-03,  -1.1147389040414223e-02,
              -3.5314241431497273e-03, 1.6872493047829493e-02,  -1.6790123962417653e-02, -4.6865441756430669e-03,
              1.5741487902192448e-02,  -5.3831022334114361e-04, -1.5045830828335787e-02, 8.1312121000207084e-04,
              2.3929125507014738e-02,  6.6419569592069318e-03,  -3.7671658629159221e-02, -1.5787870877424268e-02,
              -1.5561546524422926e-02, 2.8817064249284999e-02,  3.3582686323503294e-02,  4.4672394537303095e-02,
              -3.0954752229847719e-02, -1.4361895001944578e-02, -1.1301982224912502e-02, 1.0379352358367979e-02,
              -1.0369549976673519e-02, 3.6018996429950031e-02,  1.0434808257369144e-02,  2.6960833314889510e-02,
              -2.7559940664953521e-02, -2.4376690832867517e-02 },
            { 5.9117514436108644e-05,  -3.5668272460548816e-03, -8.4394937357837006e-03, 9.0040065743553742e-03,
              9.1282803720422133e-04,  -1.6847080771921163e-02, 4.8894925050308531e-04,  -2.3894780320477635e-05,
              -4.2308981847609776e-03, 2.0248115633234705e-02,  -4.9327721881367937e-03, -4.0878635083467299e-02,
              -1.1888358107904963e-02, -1.1689070752307729e-02, 1.8616499456864378e-02,  -3.0039665632906949e-02,
              -5.1463042602702266e-04, 1.8646891561074261e-03,  4.0922674254749207e-02,  -6.7576915678082428e-03,
              -5.9845832530947118e-03, -8.3354909557082565e-03, -4.1020127140737510e-03, -3.7136688649001236e-03,
              -9.2701490561539601e-03, 2.3857351667262106e-02,  7.1009119195751452e-02,  -1.1189199474604341e-02,
              6.8167199702625766e-03,  -1.1395947914795297e-02 },
            { -3.3322840427548919e-02, -4.3745411937679869e-03, 1.1779737097110717e-02,  -1.3874652556946258e-02,
              6.1021654355538565e-03,  1.6674146689646462e-02,  -2.4952509984992013e-02, -4.1679941336251461e-04,
              1.6647855336070785e-02,  -6.4056331293001366e-03, 2.3831515340210795e-04,  3.9757343309957175e-04,
              -3.1222188314797179e-02, -1.2050783176624251e-02, -3.2536624049349254e-02, -2.1588406475161741e-02,
              1.1583263391720128e-02,  3.1853472014597053e-02,  5.1620026325759336e-02,  1.7590034155993126e-04,
              -4.2233277326652822e-02, 7.4469721399999375e-03,  -4.0945038125741896e-03, 7.4041994380490486e-03,
              2.0605690275776380e-02,  5.0638239749296919e-04,  1.7757156158746418e-02,  5.1693542147210565e-02,
              2.3306008765999484e-03,  -2.7744238791317960e-02 },
            { -9.9405058222130915e-03, -2.2628626261912581e-02, 3.6593053070438264e-03,  9.1004892708126223e-04,
              -4.3261386935004673e-03, -1.4845034336915255e-03, -9.7466933255591689e-04, -1.4843501083377899e-02,
              -6.5779375919872837e-03, -3.6665352886220158e-04, -6.0660961658779693e-03, 5.8222116450504951e-04,
              2.1543628871878277e-02,  -5.9902713830961352e-02, -3.1448486773122050e-02, -2.1778953074626590e-02,
              8.2679247490251521e-03,  3.3146683474949687e-02,  8.4412555542390712e-03,  2.1809929192607623e-02,
              5.1886901970334375e-03,  1.1108785386450690e-02,  1.8061903966819580e-02,  -1.2420431167576568e-02,
              2.9310026102064008e-04,  3.7354662387524343e-02,  -7.9124266229991678e-04, -9.2360372424121380e-03,
              2.2272655739653570e-02,  1.0145701485145349e-02 },
            { -6.4313968766546836e-03, -1.1197131239786327e-02, -2.2484228721496961e-02, -1.2211265237584769e-04,
              -3.3720677313734808e-06, -3.6760651981027695e-03, -1.3887987200208167e-02, -6.7010375719138964e-03,
              -1.2074441840927914e-03, 1.3923498854176153e-03,  -5.2297711217686622e-03, -1.3309248827939570e-02,
              3.8631094242153163e-02,  -2.0763846352344035e-02, -1.1180528285633196e-01, -7.1549401654476229e-03,
              7.8815186170386325e-03,  1.3419883229891426e-02,  2.9038121338212913e-02,  1.2364244035814957e-02,
              -6.4805919336676085e-03, 1.7127218092980831e-02,  3.6741252808670365e-03,  6.1187699103093700e-03,
              -3.1294980243474116e-02, 1.3339651365513669e-02,  8.3525516308492184e-02,  -2.7297366420604083e-02,
              6.6356190543099963e-03,  5.5898692272938671e-02 },
            { 2.4549146156057060e-03,  -2.9192865246467389e-03, -2.7761396209006685e-03, 3.6183990593778984e-02,
              8.1606891705438358e-04,  -8.6468795455143920e-03, -1.2678894205851022e-02, 2.7185791884946784e-04,
              2.2052977624739063e-04,  1.0585407100094493e-02,  -4.3145369539683747e-03, -2.4552260608221826e-02,
              -1.2657267501053865e-01, -8.3936420997547407e-03, 7.4740651679203627e-03,  3.8435000825532226e-03,
              -8.7009967750050583e-04, 3.2445172426812954e-02,  3.4003543621538672e-02,  -6.4756012711252231e-03,
              -4.8440675381555283e-02, 1.8526502314616833e-02,  -4.9374737163909097e-03, -4.0272509914351245e-05,
              -2.0569102095352322e-02, 2.0922035718509379e-02,  3.0457006563904022e-02,  5.4222812983554074e-02,
              5.9006776889732587e-03,  1.3859453731221787e-02 },
            { -5.0253840903948278e-03, -8.2818598219666466e-03, -6.9857839497295916e-03, -2.1416591687005828e-04,
              2.6217909812788941e-02,  -2.5844018435763921e-04, -1.4400909768399927e-02, -1.9304884458178562e-02,
              7.3199788630369956e-03,  1.3037071341887225e-03,  -1.3860848027208631e-02, -6.2272692214560468e-03,
              3.2797075128281380e-02,  -1.2673973522337961e-01, -5.0855419439253015e-02, -7.4102245148416806e-03,
              4.4706771791016162e-02,  1.5490840522190557e-02,  2.0080389724325326e-02,  5.3465569827971611e-03,
              -6.2636450064972680e-03, 1.8540294270688207e-02,  2.6666081051067117e-02,  -1.5466628588110157e-02,
              -2.2874604667507271e-02, -1.6140642455487650e-03, 3.4876317711254670e-02,  -2.2796177299469873e-02,
              6.6864072138612882e-02,  2.8370049292921494e-02 },
            { 6.6050821453998119e-03,  -5.0482156455957826e-03, -9.2268377768519785e-03, -5.9152094298750156e-05,
              -1.0677586816126547e-04, 2.6599032811742550e-02,  8.6675468469743803e-04,  1.2351520076319818e-04,
              -1.3485418939582584e-02, 1.0458738008211087e-02,  9.8319553659469107e-04,  -1.8700837355290840e-02,
              6.9577559134874224e-03,  -7.3957455384003404e-03, -1.2497803412987041e-01, 1.2459074543743811e-03,
              2.3205866554279239e-04,  3.6233762443347993e-02,  2.8032549552805909e-02,  -3.0094784088970436e-04,
              -3.5797322340236776e-02, -1.6439879425292930e-02, 3.3605207095549340e-03,  4.3892960274834435e-02,
              -7.3526445638263617e-03, 8.1390516337566336e-03,  3.4271974786427828e-03,  -3.0315111675558011e-02,
              1.3343146834845739e-05,  9.2035497533264801e-02 }
        };
    }


    template<>
    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP2P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::displacement>()
    {
        return expected_results_type<LinearAlgebraNS::type::vector>{
            0.026707676206855515,  -0.023799949026614725, -0.04374928780187741,  0.008475207120205773,
            -0.005901542458782882, -0.013638763198605344, -0.013003414592682807, 0.0049101285205963826,
            0.033079776067729216,  -0.02217946873437848,  0.02479136296480122,   0.024308274932753532
        };
    }


} // namespace MoReFEM::TestNS::ViscoelasticityNS
// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)


// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
